<CsoundSynthesizer>
<CsInstruments>

/***************************************************

	Noise Synth.

***************************************************/

nchnls = 2 

instr 1

	; oscil 1
	kpit invalue "pitch"
	kpan invalue "pan"
	if (kpan == 0) then
		kpan = .5;randh 1, 10 
	endif
	kpan port kpan, .05

	; lfo
	kLFOpitch invalue "LFOpitch"
	kLFOpitch port kLFOpitch, .01

	kLFOamp invalue "LFOamp"
	kLFOamp port kLFOamp, .01

	; wave
	kfunc init 1
	knewf	invalue "wave"
	if (kfunc != knewf) then
		kfunc = knewf
		tablecopy 10, kfunc
	endif
	
	; calculate pitch - using a "wrong" way to use cpspch to get intersting results..
	kpitchfac invalue "pitchfac"
	kpitch port cpspch(kpit*15*kpitchfac), .005

	klfo oscili kLFOamp*kpitch/10, kLFOpitch*20, 1
	asig oscili .9*0dbfs, kpitch+klfo, 10


	; reverb
	krevamtL	invalue	"revamtL"
	krevtimeL 	invalue 	"revtimL"
	krevamtR	invalue	"revamtR"
	krevtimeR 	invalue 	"revtimR"

	arevl reverb asig, 5*krevtimeL
	arevr reverb asig, 5* krevtimeR

	; output
	aoutl = arevl*krevamtL*.1 + asig*(1-kpan)
	aoutr = arevr*krevamtR*.1 + asig*kpan

	; show levels
	krmsl rms aoutl
	outvalue "rmsl", krmsl/0dbfs
	krmsr rms aoutr
	outvalue "rmsr", krmsr/0dbfs
	

	outs aoutl, aoutr
endin
</CsInstruments>
<CsScore>
f1 0 512 10 1	; sine wave
f2  0  512  5  .01  256  1  256  .01 ; triangle
f3  0  512  10  1  0  .9  0  .8  0  .7  0  .6  0  .5  0  .4   0  .3  0  .2   0  .1  ; square
f4  0  512  21  1  1 ; noise
f5  0  512  7  -1  500 1  12  -1 ; saw1
f6  0  512  10  1  .95  .9  .85  .8  .75  .7  .65  .6  .55  .5  .45  .4  .35  .3  .25   .2   .15  .1  .05 ; saw2
f7  0  512  10  1  1  1  1  1 ;buzz1
f8  0  512  10  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1 ;buzz2

f10 0 512 10 1 ; the function we actually use

f0 8888
                                                                                                                                                                                                                                                                                                         

i1 0 8888
</CsScore>

</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: None
Functions: None
WindowBounds: 17 44 517 561
CurrentView: io
IOViewEdit: Off
Options: -b512 -A -s -m7 -R 
</MacOptions>
<MacGUI>
ioView background {25502, 23889, 23587}
ioText {234, 281} {32, 24} label 0.000000 0.001000 "" left "Futura" 9 {0, 0, 0} {65535, 65535, 65535} nobackground noborder amp
ioText {258, 297} {32, 24} label 0.000000 0.001000 "" left "Futura" 9 {0, 0, 0} {65535, 65535, 65535} nobackground noborder time
ioText {234, 311} {32, 24} label 0.000000 0.001000 "" left "Futura" 9 {0, 0, 0} {65535, 65535, 65535} nobackground noborder amp
ioText {259, 314} {160, 62} label 0.000000 0.001000 "" right "Futura" 20 {0, 0, 0} {65535, 65535, 65535} nobackground border Reverb R
ioText {238, 198} {28, 24} label 0.000000 0.001000 "" left "Futura" 9 {0, 0, 0} {65535, 65535, 65535} nobackground noborder cpspan
ioText {259, 213} {34, 28} label 0.000000 0.001000 "" left "Futura" 9 {0, 0, 0} {65535, 65535, 65535} nobackground noborder amp
ioText {238, 90} {28, 24} label 0.000000 0.001000 "" left "Futura" 9 {0, 0, 0} {65535, 65535, 65535} nobackground noborder cpspan
ioText {260, 74} {28, 24} label 0.000000 0.001000 "" left "Futura" 9 {0, 0, 0} {65535, 65535, 65535} nobackground noborder pan
ioText {259, 92} {164, 61} label 0.000000 0.001000 "" right "Futura" 20 {0, 0, 0} {65535, 65535, 65535} nobackground border Oscillator
ioMeter {254, 87} {78, 72} {65535, 12903, 12130} "pan" 0.000000 "pitch" 0.000000 point 6 739 mousezero
ioMenu {334, 122} {86, 34} 1 202 "sine,triangle,square,noise,saw1,saw2,buzz1,buzz2" wave
ioText {259, 158} {116, 63} label 0.000000 0.001000 "" right "Futura" 20 {0, 0, 0} {65535, 65535, 65535} nobackground border LFO
ioMeter {253, 152} {78, 74} {33816, 45580, 65535} "LFOamp" 0.287879 "LFOpitch" 0.451613 crosshair 1 0 mouse
ioText {259, 241} {161, 61} label 0.000000 0.001000 "" right "Futura" 20 {0, 0, 0} {65535, 65535, 65535} nobackground border Reverb L
ioMeter {253, 235} {78, 74} {65535, 33653, 3183} "revtimL" 0.212121 "revamtL" 0.193548 crosshair 1 0 mouse
ioMeter {253, 308} {78, 74} {65535, 33406, 2168} "revtimR" 0.242424 "revamtR" 0.274194 crosshair 1 0 mouse
ioMeter {327, 118} {16, 37} {6435, 65535, 5208} "" 0.250000 "pitchfac" 0.520000 fill 1 0 mouse
ioText {20, 17} {202, 72} label 0.000000 0.001000 "" left "Futura" 12 {0, 0, 0} {65535, 65535, 65535} nobackground border drag mouse inside oscillator box
</MacGUI>
