<CsoundSynthesizer>
<CsInstruments>
/* graphic equalizer
		-ma++ 7/04

	spectral display of input
		and simple parametric eq

	make sure your input device is set properly
	in the preferences
*/


sr		=	44100
ksmps		=	100
nchnls	=	2

gkgain	init	1


; an opcode that calls itself recursively to update the graphs
opcode updateGraphs, 0, iii

	istartCh, ioffset, ifn xin

	if (istartCh < 24) then
		kamp	init	0
		ksig table istartCh, ifn
		kamp port	ksig/gkgain, .02

		outvalue istartCh+ioffset, kamp
		updateGraphs istartCh + 1, ioffset, ifn
	endif

endop

instr 1	
	inbins	=	128
	ifftsize	=	256

	; make ftables
	iampfl	ftgen	0,0,inbins, 2, 0        
	iampfr	ftgen	0,0,inbins, 2, 0
	ifiltfl	ftgen	0,0,inbins, 7, .5, inbins, .5
	ifiltfr	ftgen	0,0,inbins, 7, .5, inbins, .5

	a1, a2	ins

	; read the eq params
	keq	invalue "eq1"
		tablew	keq, 3, ifiltfl



	; analyse and write to ftables
	fsigl 	pvsanal a1, ifftsize, ifftsize/2, ifftsize, 0
	kflagl 	pvsftw fsigl, iampfl	
	
	fsigr 	pvsanal a2, ifftsize, ifftsize/2, ifftsize, 0
	kflagr 	pvsftw fsigr, iampfr


	if (kflagl != 0) then
		; apply eq
		keq 	invalue 	"eql1"
		kval 	table 0, 	iampfl
			tablew	keq*kval,0,iampfl
		kval 	table 1, 	iampfl
			tablew	keq*kval,1,iampfl
		kval 	table 2, 	iampfl
			tablew	keq*kval,2,iampfl
		kval 	table 3, 	iampfl
			tablew	keq*kval,3,iampfl

		keq 	invalue 	"eql2"
		kval 	table 4, 	iampfl
			tablew	keq*kval,4,iampfl
		kval 	table 5, 	iampfl
			tablew	keq*kval,5,iampfl
		kval 	table 6, 	iampfl
			tablew	keq*kval,6,iampfl
		kval 	table 7, 	iampfl
			tablew	keq*kval,7,iampfl

		keq 	invalue 	"eql3"
		kval 	table 8, 	iampfl
			tablew	keq*kval,8,iampfl
		kval 	table 9, 	iampfl
			tablew	keq*kval,9,iampfl
		kval 	table 10, 	iampfl
			tablew	keq*kval,10,iampfl
		kval 	table 11, 	iampfl
			tablew	keq*kval,11,iampfl

		keq 	invalue 	"eql4"
		kval 	table 12, 	iampfl
			tablew	keq*kval,12,iampfl
		kval 	table 13, 	iampfl
			tablew	keq*kval,13,iampfl
		kval 	table 14, 	iampfl
			tablew	keq*kval,14,iampfl
		kval 	table 15, 	iampfl
			tablew	keq*kval,15,iampfl

		keq 	invalue 	"eql5"
		kval 	table 16, 	iampfl
			tablew	keq*kval,16,iampfl
		kval 	table 17, 	iampfl
			tablew	keq*kval,17,iampfl
		kval 	table 18, 	iampfl
			tablew	keq*kval,18,iampfl
		kval 	table 19, 	iampfl
			tablew	keq*kval,19,iampfl

		keq 	invalue 	"eql6"
		kval 	table 20, 	iampfl
			tablew	keq*kval,20,iampfl
		kval 	table 21, 	iampfl
			tablew	keq*kval,21,iampfl
		kval 	table 22, 	iampfl
			tablew	keq*kval,22,iampfl
		kval 	table 23, 	iampfl
			tablew	keq*kval,23,iampfl

		; update graphs
		gkgain	invalue "gain"
		updateGraphs 0, 0, iampfl


		; resynthesize		
		pvsftr      fsigl, iampfl
	endif

	if (kflagr != 0) then
		; apply eq
		keq 	invalue 	"eqr1"
		kval 	table 0, 	iampfr
			tablew	keq*kval,0,iampfr
		kval 	table 1, 	iampfr
			tablew	keq*kval,1,iampfr
		kval 	table 2, 	iampfr
			tablew	keq*kval,2,iampfr
		kval 	table 3, 	iampfr
			tablew	keq*kval,3,iampfr

		keq 	invalue 	"eqr2"
		kval 	table 4, 	iampfr
			tablew	keq*kval,4,iampfr
		kval 	table 5, 	iampfr
			tablew	keq*kval,5,iampfr
		kval 	table 6, 	iampfr
			tablew	keq*kval,6,iampfr
		kval 	table 7, 	iampfr
			tablew	keq*kval,7,iampfr

		keq 	invalue 	"eqr3"
		kval 	table 8, 	iampfr
			tablew	keq*kval,8,iampfr
		kval 	table 9, 	iampfr
			tablew	keq*kval,9,iampfr
		kval 	table 10, 	iampfr
			tablew	keq*kval,10,iampfr
		kval 	table 11, 	iampfr
			tablew	keq*kval,11,iampfr

		keq 	invalue 	"eqr4"
		kval 	table 12, 	iampfr
			tablew	keq*kval,12,iampfr
		kval 	table 13, 	iampfr
			tablew	keq*kval,13,iampfr
		kval 	table 14, 	iampfr
			tablew	keq*kval,14,iampfr
		kval 	table 15, 	iampfr
			tablew	keq*kval,15,iampfr

		keq 	invalue 	"eqr5"
		kval 	table 16, 	iampfr
			tablew	keq*kval,16,iampfr
		kval 	table 17, 	iampfr
			tablew	keq*kval,17,iampfr
		kval 	table 18, 	iampfr
			tablew	keq*kval,18,iampfr
		kval 	table 19, 	iampfr
			tablew	keq*kval,19,iampfr

		keq 	invalue 	"eqr6"
		kval 	table 20, 	iampfr
			tablew	keq*kval,20,iampfr
		kval 	table 21, 	iampfr
			tablew	keq*kval,21,iampfr
		kval 	table 22, 	iampfr
			tablew	keq*kval,22,iampfr
		kval 	table 23, 	iampfr
			tablew	keq*kval,23,iampfr

		; update graphs
		updateGraphs 0, 24, iampfr

		; resynthesize		
		pvsftr      fsigr, iampfr
	endif


	aoutl  pvsynth   fsigl
	aoutr  pvsynth   fsigr
	outs aoutr, aoutr
endin
</CsInstruments>
<CsScore>
f1 0 512 10 1
i1	0	9999
</CsScore>

</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: Window
Listing: Window
WindowBounds: 227 106 1222 841
CurrentView: io
IOViewEdit: Off
Options: -b512 -A -s -m167 -R 
</MacOptions>
<MacGUI>
ioView background {18385, 18385, 18385}
ioText {459, 128} {281, 193} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {11565, 10353, 11262} background border 
ioText {114, 128} {287, 194} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {11565, 10353, 11262} background border 
ioMeter {165, 140} {18, 169} {44563, 53738, 65535} "4" 0.000000 "4" 0.000000 fill 1 0 notrack
ioMeter {132, 140} {18, 169} {44563, 53738, 65535} "1" 0.000000 "1" 0.000000 fill 1 0 notrack
ioMeter {154, 140} {18, 169} {44563, 53738, 65535} "3" 0.000000 "3" 0.000000 fill 1 0 notrack
ioMeter {143, 140} {18, 169} {44563, 53738, 65535} "2" 0.000000 "2" 0.000000 fill 1 0 notrack
ioMeter {176, 140} {18, 169} {44563, 53738, 65535} "5" 0.000000 "5" 0.000000 fill 1 0 notrack
ioMeter {187, 140} {18, 169} {44563, 53738, 65535} "6" 0.000000 "6" 0.000000 fill 1 0 notrack
ioMeter {253, 140} {18, 169} {44563, 53738, 65535} "12" 0.000000 "12" 0.000000 fill 1 0 notrack
ioMeter {231, 140} {18, 169} {44563, 53738, 65535} "10" 0.000000 "10" 0.000000 fill 1 0 notrack
ioMeter {242, 140} {18, 169} {44563, 53738, 65535} "11" 0.000000 "11" 0.000000 fill 1 0 notrack
ioMeter {220, 140} {18, 169} {44563, 53738, 65535} "9" 0.000000 "9" 0.000000 fill 1 0 notrack
ioMeter {198, 140} {18, 169} {44563, 53738, 65535} "7" 0.000000 "7" 0.000000 fill 1 0 notrack
ioMeter {209, 140} {18, 169} {44563, 53738, 65535} "8" 0.000000 "8" 0.000000 fill 1 0 notrack
ioSlider {413, 129} {34, 192} 2000.000000 50.000000 2000.000000 gain
ioMeter {121, 140} {18, 169} {44563, 53738, 65535} "0" 0.000000 "0" 0.000000 fill 1 0 notrack
ioMeter {363, 140} {18, 169} {44563, 53738, 65535} "22" 0.000000 "22" 0.000000 fill 1 0 notrack
ioMeter {374, 140} {18, 169} {44563, 53738, 65535} "23" 0.000000 "23" 0.000000 fill 1 0 notrack
ioMeter {352, 140} {18, 169} {44563, 53738, 65535} "21" 0.000000 "21" 0.000000 fill 1 0 notrack
ioMeter {341, 140} {18, 169} {44563, 53738, 65535} "20" 0.000000 "20" 0.000000 fill 1 0 notrack
ioMeter {319, 140} {18, 169} {44563, 53738, 65535} "18" 0.000000 "18" 0.000000 fill 1 0 notrack
ioMeter {330, 140} {18, 169} {44563, 53738, 65535} "19" 0.000000 "19" 0.000000 fill 1 0 notrack
ioMeter {297, 140} {18, 169} {44563, 53738, 65535} "16" 0.000000 "16" 0.000000 fill 1 0 notrack
ioMeter {308, 140} {18, 169} {44563, 53738, 65535} "17" 0.000000 "17" 0.000000 fill 1 0 notrack
ioMeter {286, 140} {18, 169} {44563, 53738, 65535} "15" 0.000000 "15" 0.000000 fill 1 0 notrack
ioMeter {275, 140} {18, 169} {44563, 53738, 65535} "14" 0.000000 "14" 0.000000 fill 1 0 notrack
ioMeter {264, 140} {18, 169} {44563, 53738, 65535} "13" 0.000000 "13" 0.000000 fill 1 0 notrack
ioMeter {717, 141} {18, 169} {44563, 53738, 65535} "47" 0.052830 "47" 0.052830 fill 1 0 notrack
ioMeter {706, 141} {18, 169} {44563, 53738, 65535} "46" 0.057726 "46" 0.057726 fill 1 0 notrack
ioMeter {695, 141} {18, 169} {44563, 53738, 65535} "45" 0.071684 "45" 0.071684 fill 1 0 notrack
ioMeter {684, 141} {18, 169} {44563, 53738, 65535} "44" 0.034147 "44" 0.034147 fill 1 0 notrack
ioMeter {673, 141} {18, 169} {44563, 53738, 65535} "43" 0.040991 "43" 0.040991 fill 1 0 notrack
ioMeter {651, 141} {18, 169} {44563, 53738, 65535} "41" 0.047044 "41" 0.047044 fill 1 0 notrack
ioMeter {662, 141} {18, 169} {44563, 53738, 65535} "42" 0.058583 "42" 0.058583 fill 1 0 notrack
ioMeter {629, 141} {18, 169} {44563, 53738, 65535} "39" 0.060834 "39" 0.060834 fill 1 0 notrack
ioMeter {640, 141} {18, 169} {44563, 53738, 65535} "40" 0.047373 "40" 0.047373 fill 1 0 notrack
ioMeter {618, 141} {18, 169} {44563, 53738, 65535} "38" 0.052767 "38" 0.052767 fill 1 0 notrack
ioMeter {585, 141} {18, 169} {44563, 53738, 65535} "35" 0.022565 "35" 0.022565 fill 1 0 notrack
ioMeter {563, 141} {18, 169} {44563, 53738, 65535} "33" 0.032636 "33" 0.032636 fill 1 0 notrack
ioMeter {574, 141} {18, 169} {44563, 53738, 65535} "34" 0.027559 "34" 0.027559 fill 1 0 notrack
ioMeter {607, 141} {18, 169} {44563, 53738, 65535} "37" 0.037917 "37" 0.037917 fill 1 0 notrack
ioMeter {596, 141} {18, 169} {44563, 53738, 65535} "36" 0.041178 "36" 0.041178 fill 1 0 notrack
ioMeter {508, 141} {18, 169} {44563, 53738, 65535} "28" 0.128911 "28" 0.128911 fill 1 0 notrack
ioMeter {519, 141} {18, 169} {44563, 53738, 65535} "29" 0.074563 "29" 0.074563 fill 1 0 notrack
ioMeter {552, 141} {18, 169} {44563, 53738, 65535} "32" 0.041855 "32" 0.041855 fill 1 0 notrack
ioMeter {530, 141} {18, 169} {44563, 53738, 65535} "30" 0.074483 "30" 0.074483 fill 1 0 notrack
ioMeter {541, 141} {18, 169} {44563, 53738, 65535} "31" 0.044639 "31" 0.044639 fill 1 0 notrack
ioMeter {497, 141} {18, 169} {44563, 53738, 65535} "27" 0.526926 "27" 0.526926 fill 1 0 notrack
ioMeter {486, 141} {18, 169} {44563, 53738, 65535} "26" 1.152894 "26" 1.152894 fill 1 0 notrack
ioMeter {475, 141} {18, 169} {44563, 53738, 65535} "25" 0.659627 "25" 0.659627 fill 1 0 notrack
ioMeter {464, 141} {18, 169} {44563, 53738, 65535} "24" 0.396727 "24" 0.396727 fill 1 0 notrack
ioKnob {300, 323} {48, 48} 0.000000 10.000000 0.100000 0.000000 eql5
ioKnob {347, 323} {48, 48} 0.000000 10.000000 0.100000 0.000000 eql6
ioKnob {253, 323} {48, 48} 0.000000 10.000000 0.100000 0.000000 eql4
ioKnob {206, 323} {48, 48} 0.000000 10.000000 0.100000 0.000000 eql3
ioKnob {159, 323} {48, 48} 0.000000 10.000000 0.100000 0.000000 eql2
ioKnob {112, 323} {48, 48} 0.000000 10.000000 0.100000 0.000000 eql1
ioKnob {642, 321} {48, 48} 0.000000 10.000000 0.100000 1.600000 eqr5
ioKnob {689, 321} {48, 48} 0.000000 10.000000 0.100000 1.400000 eqr6
ioKnob {595, 321} {48, 48} 0.000000 10.000000 0.100000 1.600000 eqr4
ioKnob {548, 321} {48, 48} 0.000000 10.000000 0.100000 0.600000 eqr3
ioKnob {501, 321} {48, 48} 0.000000 10.000000 0.100000 0.500000 eqr2
ioKnob {454, 321} {48, 48} 0.000000 10.000000 0.100000 0.600000 eqr1
</MacGUI>
