<CsoundSynthesizer>
<CsInstruments>
;================================================================
;		guidemo.csd			matt ingalls
;													
;	the beginnings of a kind of "port" of the mills
;	macintosh score generator using the 'event' ocode
;
;  	instead of using an external score generator, notes are 
;	spawned internally by instrument 2.  this orchestra is 
;	meant to be used in real-time moving the control sliders
; 
;===============================================================

        sr      =		44100
        ksmps   =		10
        nchnls  =      2

galeft init 0
garight init 0

	instr 1	; this instrument makes the noise!

;if (p6 == 0) then
	al 	loscil	p4, p5, 12, 1
;else
;	al, ar 	loscil3	p4, p5, 12, 1
;endif
 		outs		al, al;ar
galeft	=		galeft  + al
garight	=		garight + al;ar

	endin




   instr 2	; the 'event generator' instrument

kcnt init 0
knexttime init 0


if kcnt >= knexttime then	; you can now use if/then/else/endif statements!!

	kdenmin  	invalue 	"Density Min"
	kdenmax  	invalue 	"Density Max"
	kdurmin	invalue 	"Dur Min"
	kgain    	invalue 	"Gain"
	kpitmin	invalue 	"Pitch Min"
	kpitmax  	invalue 	"Pitch Max"
	
	kpitch 	linrand 	4*kpitmax
	kpan 		linrand 	1

	kinterp	invalue	"interp"
        		event 	"i", 1, 0, .1+kdurmin*2, kgain, .1+kpitmin*kpitmin+kpitch, kinterp

	outvalue "new pitch", kpitch

	ktest linrand kdenmax * kr
knexttime = (kdenmin*kr + ktest)/8
	knexttime = 8 * int(knexttime)
	kcnt = 0

endif


; k-rate display output
ktime times
outvalue "time", ktime
outvalue "countdown", (knexttime-kcnt)/kr

kleft		rms	galeft
kright	rms	garight
outvalue "left rms", kleft/32768
outvalue "right rms", kright/32768
galeft = 0
garight = 0

	kcnt = kcnt + 1 

endin
 


   instr 3	; this instrument triggers a new note for every keyboard keystroke

kcnt init 0
knexttime init 0

klastkey init -1
key sense

if key != -1 then

	printks "got one", 0

	kdenmin  	invalue 	"Density Min"
	kdenmax  	invalue 	"Density Max"
	kdurmin	invalue 	"Dur Min"
	kgain    	invalue 	"Gain"
	kpitmin	invalue 	"Pitch Min"
	kpitmax  	invalue 	"Pitch Max"

	if key != klastkey then
		kpitch 	linrand 	4*kpitmax
	endif ; else keep the same pitch 
	
	kpan 		linrand 	1
        		event 	"i", 1, 0, .1+kdurmin*2, kgain*(key/64), .25+4*kpitmin*kpitmin+kpitch

	outvalue "new pitch", kpitch

	ktest linrand kdenmax * kr
	knexttime = kdenmin*kr + ktest
	kcnt = 0

	klastkey = key	

endif

endin

</CsInstruments>
<CsScore>
f1      0       8192     10      1			;  	sine wave
f2      0       129     7       1  129  0   	;  	table 1
f3      0       129     5       .01   129    1	; 	vib envlp

; pan functions [.25 of a sine wave is close enough to sqrt..]
f10		0		129		9	.25	1	90	; left
f11		0		129		9	.25	1	00	; right

f12 0 0 -1  "wine.aif" 0 0 0

i2	0 	600
</CsScore>

</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: ioObject
WindowBounds: 283 44 1018 682
CurrentView: orc
IOViewEdit: Off
Options: -b512 -A -s -m7 -R 
</MacOptions>
<MacGUI>
ioView background {27421, 29038, 37660}
ioText {264, 154} {85, 31} label 0.000000 0.001000 "" center "Futura" 12 {0, 0, 0} {65535, 65535, 65535} nobackground noborder interpolation
ioText {358, 166} {41, 24} label 0.000000 0.001000 "" center "Futura" 9 {0, 0, 0} {65535, 65535, 65535} nobackground noborder cubic
ioText {320, 166} {38, 29} label 0.000000 0.001000 "" center "Futura" 9 {0, 0, 0} {65535, 65535, 65535} nobackground noborder linear
ioSlider {58, 151} {34, 117} 0.000000 5.000000 1.569500 Pitch Min
ioSlider {99, 150} {34, 118} 0.000000 5.000000 0.862000 Pitch Max
ioText {45, 16} {156, 28} label 0.000000 0.001000 "" left "Futura" 12 {0, 0, 0} {65535, 65535, 65535} nobackground noborder Minimum Density [sec]
ioText {148, 30} {70, 24} display 0.877997 0.001000 "Density Min" left "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioText {276, 93} {46, 31} display 0.472789 0.100000 "countdown" left "Skia" 16 {0, 0, 0} {53739, 57869, 65535} background border 
ioText {150, 71} {70, 24} display 0.000100 0.001000 "Density Max" left "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioText {45, 58} {156, 26} label 0.000000 0.001000 "" left "Futura" 12 {0, 0, 0} {65535, 65535, 65535} nobackground noborder Density Variation [sec]
ioText {217, 75} {134, 24} label 0.000000 0.001000 "" left "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder seconds until next note:
ioText {274, 41} {49, 28} display 123.730614 0.100000 "time" left "Skia" 16 {0, 0, 0} {53739, 57869, 65535} background border 
ioText {255, 21} {134, 24} label 0.000000 0.001000 "" left "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder seconds since start:
ioText {45, 129} {45, 32} label 0.000000 0.001000 "" center "Copperplate" 18 {0, 0, 0} {65535, 65535, 65535} nobackground noborder Min
ioText {94, 130} {49, 32} label 0.000000 0.001000 "" center "Copperplate" 18 {0, 0, 0} {65535, 65535, 65535} nobackground noborder Max
ioText {57, 119} {86, 28} label 0.000000 0.001000 "" center "Futura" 12 {0, 0, 0} {65535, 65535, 65535} nobackground noborder Pitch Range
ioText {120, 144} {47, 24} display 0.862000 0.001000 "Pitch Max" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioText {25, 143} {47, 24} display 1.569500 0.001000 "Pitch Min" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioSlider {44, 70} {98, 34} 0.000100 3.000000 0.000100 Density Max
ioSlider {50, 29} {93, 34} 0.010000 3.000000 0.877997 Density Min
ioText {275, 290} {44, 25} label 0.000000 0.001000 "" center "Lucida Grande" 12 {0, 0, 0} {65535, 65535, 65535} nobackground noborder Gain
ioText {226, 215} {68, 27} label 0.000000 0.001000 "" center "Lucida Grande" 12 {0, 0, 0} {65535, 65535, 65535} nobackground noborder Duration
ioSlider {241, 226} {101, 34} 0.010000 1.000000 0.759529 Dur Min
ioSlider {283, 301} {61, 34} 0.000000 1.000000 0.700000 Gain
ioText {297, 284} {47, 24} display 0.700000 0.001000 "Gain" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioText {258, 209} {47, 24} display 0.759529 0.001000 "Dur Min" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioText {181, 176} {100, 27} display 2.110126 0.001000 "new pitch" left "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioMeter {350, 204} {10, 130} {44563, 53738, 65535} "left rms" 0.021648 "left rms" 0.021648 fill 1 0 notrack
ioMeter {361, 204} {10, 130} {44563, 53738, 65535} "right rms" 0.021648 "right rms" 0.021648 fill 1 0 notrack
ioButton {51, 284} {174, 57} event 1.000000 "" "start notes triggeredby keyboard strokes" "/" i3 0 999
ioListing {11, 359} {398, 160}
ioGraph {410, 14} {265, 505}
ioKnob {336, 133} {48, 48} 0.000000 1.000000 1.000000 1.000000 interp
ioText {145, 166} {134, 24} label 0.000000 0.001000 "" left "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder new pitch:
</MacGUI>
