<CsoundSynthesizer>
<CsInstruments>
/*


*********************************************************************

	MacCsound Tutorial #1
	

	This first tutorial is to get you familiar with the
	MacCsound interface.

	Each Csound project is contained in a single window,
	divided into 4 panels [orc, sco, i/o, options].

	This panel [orc] is the orchestra section of the project
	where you define your csound instruments.  Here, we define a 
	simple pluck instrument.  [ We will get into the details 
 	of orchestra syntax in later tutorials ]


	Now, click on the 'sco' tab [or press cmd-2] 
	to view to the score.
	

*********************************************************************


*/


instr my_pluck

	a1 pluck .5*0dbfs, 440, 440, 0, 1
	out a1

endin
</CsInstruments>
<CsScore>
;***********************************************************************
;
;	This is the "score" panel, where you specify 
;	function tables and note events.
;
;	In this project, we are playing one note starting
;	at time 0 for a duration of 2 seconds. 
;
;	We also define a couple of function tables.
;
;	Now click on the 'i/o' tab [or cmd-3] to go to the i/o view.
;
;**********************************************************************

i "my_pluck" 0 20


f1 0 512 10 1 	; a sine wave
f2 0 8 7 0 8 1 	; ramp 0 to 1



</CsScore>

</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: ioObject
WindowBounds: 107 44 965 768
CurrentView: orc
IOViewEdit: On
Options: -b512 -A -s -m7 -R 
</MacOptions>
<MacGUI>
ioView background {65535, 64430, 54530}
ioText {437, 291} {384, 295} label 0.000000 0.001000 "" center "Futura" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border These are the function table graphs
ioGraph {454, 319} {350, 242}
ioText {49, 291} {384, 295} label 0.000000 0.001000 "" center "Futura" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border This is the text output of the csound process
ioText {138, 232} {216, 26} label 0.000000 0.001000 "" center "Copperplate Light" 12 {0, 0, 0} {65535, 65535, 65535} nobackground noborder for example, here is a slider --->
ioText {384, 215} {56, 24} display 1.000000 0.001000 "test" left "Lucida Grande" 11 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioListing {72, 318} {343, 241}
ioText {88, 89} {254, 85} label 0.000000 0.001000 "" center "Futura" 16 {0, 0, 0} {65535, 65535, 65535} nobackground border This is the view where you define your own interface for input and display data.
ioText {517, 42} {195, 242} label 0.000000 0.001000 "" center "Optima ExtraBlack" 18 {0, 0, 0} {44665, 65535, 41195} background border To play our sound, press the green arrow button in the upper right corner of the window!
ioText {220, 158} {212, 24} label 0.000000 0.001000 "" center "Lucida Grande" 9 {0, 0, 0} {65535, 54120, 41947} background border we will get into the details in later tutorials
ioSlider {347, 228} {82, 34} 0.000000 1.000000 1.000000 test
ioText {135, 683} {504, 46} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border The next and final panel, "options" is where you can set various preferences relative to this project. [You set global options in the Preferences Window opened from the 'MacCsound' menu]
ioText {201, 724} {520, 42} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border You can click on 'options' [cmd-4] to get familiar with the panel now, but know that usually you will just use the default options already set for you and you will not have to adjust anything for normal use.
ioText {8, 0} {813, 24} label 0.000000 0.001000 "" left "Lucida Grande" 9 {0, 0, 0} {65535, 65535, 65535} nobackground noborder the button in the bottom right corner of the window lets you 'lock/unlock' the interface. [ you can also hold down the cmd key while clicking on any open space in this view ]
</MacGUI>
