<CsoundSynthesizer>
<CsInstruments>
/**********************************************************************

	MacCsound Tutorial #5
	

	Csound Language Basics (3) - dynamic changes


	Parameters can be changed dynamically over the duration of
	a note.  Here we use the same oscillator instrument, but
	add an envelope to the amplitude and pitch

**********************************************************************/

instr 1	
	; we still specify p4=amp and p5=pitch, but
	; now those values are the starting point that we will 
	; move from. to do this gradual change, we use the 
	; 'line' opcode which has this syntax:
	;
	;	kOutValue line iStartValue, iDuration, iEndValue
	;
	; so, 'line' begins by outputting iStartValue, and gradually
	; changes that value, approaching iEndValue by iDuration seconds.
	; the most common value used for iDuration is p3 (the note's duration) 
	; and this is what we do here:
  
	kAmplitude	line	p4, p3, 0		; goes from p4 to 0 (linear fade out)
	kPitch	line	p5, p3, 1000	; goes from p5 to 1000hz

	asig oscili kAmplitude, kPitch, 1	; notice we use the ouputs from the 'line's for our oscil ins

	out asig	; send the signal to the output

endin			


</CsInstruments>
<CsScore>
; note this is the exact same score as Tutorial #4

f1 0 512 10 1 	; out sine wave


; now our notes 

; any instrument can use any number of pfields, [ but must use at least 3 ]  
; here we use 5, where p4 = amp and p5 = pitch.

;i#	start	dur	amp	cps <----- often, people put comments above a segment of notes showing what each pfield is:
;p1	p2	p3	p4	p5

i1	0	3	5000	500
i1	1	2	2000	750
i1	2	2	7000	100
i1 	2.5 	3	5000	4000

</CsScore>

</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: ioObject
WindowBounds: 72 44 918 687
CurrentView: orc
IOViewEdit: Off
Options: -b512 -A -s -m7 -R 
</MacOptions>
<MacGUI>
ioView nobackground {65535, 65535, 65535}
ioListing {10, 10} {400, 500}
ioGraph {409, 15} {300, 500}
</MacGUI>
