<CsoundSynthesizer>
<CsInstruments>
/**********************************************************************

	MacCsound Tutorial #6

	
	MacCsound GUI i/o (1)

	
	The last tutorial showed how to use the 'line' opcode to
	generate changing parameters.  This tutorial shows how you
	can create a user interface to change parameters in real-time.

**********************************************************************/


instr 1 

	; We replace the 'line' opcodes from the last tutorial with
	; 'invalue' opcodes.  The 'invalue' opcode returns a value
	; from an i/o object.  i/o objects send their values on
	; assigned channels.  You specifiy the name of the channel
	; as an input parameter to 'invalue'.  GOTO the i/o view
	; to see how the interface is specified.

	kAmplitude	invalue "amplitude" 	; these 2 lines read in the
	kPitch	invalue "pitch"		; current value of the sliders


	; the 'port' opcode smooths out jumps from the low pixel resolution of the sliders
	kAmplitude	port kAmplitude, .01, 0		; 	( you dont necessarily need to understand all this right )
	kPitch	port kPitch, .01, i(kPitch)	; 	( now, but feel free to look up the 'port' opcode )
								; 	( and the i() function in the manual if you want! )
		

	asig oscili kAmplitude, kPitch, 1
	out asig			

endin
</CsInstruments>
<CsScore>
f1 0 512 10 1 ; sinewave

i1 0 9999 	; the note - a VERY long duration! - since this is a "real-time"
		; instrument, we assume you will end the sound by hitting the stop
		; button (red 'X' at the top right of the window)
</CsScore>

</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 405 44 1251 687
CurrentView: orc
IOViewEdit: Off
Options: -b512 -A -s -m7 -R 
</MacOptions>
<MacGUI>
ioView background {56489, 65535, 63981}
ioText {44, 119} {249, 82} label 0.000000 0.001000 "" center "Futura" 14 {0, 0, 0} {65535, 65535, 65535} nobackground border amplitude
ioText {270, 143} {87, 29} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder <-----------
ioText {43, 207} {250, 80} label 0.000000 0.001000 "" center "Futura" 14 {0, 0, 0} {65535, 65535, 65535} nobackground border pitch
ioSlider {58, 233} {213, 34} 20.000000 5000.000000 2152.934082 pitch
ioGraph {333, 272} {389, 230}
ioText {145, 54} {289, 46} label 0.000000 0.001000 "" center "Futura" 12 {0, 0, 0} {65535, 58412, 50269} background border This is a simple interface to control our instrument.  A slider for pitch and a slider for amplitude.
ioText {341, 131} {314, 41} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border Click on the border of the slider to select it.  Once selected, you then will see its attributes in the panel above.
ioText {310, 168} {247, 64} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border Notice there is the channel name, which corresponds to the name specified in the "invalue" opcode in the orc.  You can also set the max/min range for the slider.
ioSlider {59, 147} {210, 34} 0.000000 10000.000000 4301.000000 amplitude
ioText {6, 7} {479, 36} label 0.000000 0.001000 "" center "Lucida Grande" 9 {0, 0, 0} {65535, 65535, 65535} nobackground noborder to edit this interface, first make sure you are in 'unlocked' mode.  if you do not see a number of buttons in the upper left corner, hit the button in the lower right corner of the window.
ioText {19, 315} {293, 47} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border To create a new object, just hit one of the buttons in the upper left corner of the window.  For an example, hit the text object button, the one with a 'T' on it.
ioText {19, 361} {293, 48} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border You should then see a new box text box.   Under the "Function" attribute, notice that it is set to "None [Static Label]"  This is how you can create comments like these.
ioText {19, 408} {293, 62} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border Now switch the function to "Value Display" and in the edit text box below type "pitch".  This will make the text box display the value of the "pitch" channel [the channel the pitch slider is writing to]
ioText {19, 469} {293, 26} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border Feel free to try creating or modifying other objects!
ioText {44, 119} {249, 82} label 0.000000 0.001000 "" center "Futura" 14 {0, 0, 0} {65535, 65535, 65535} nobackground border amplitude
ioText {270, 143} {87, 29} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder <-----------
ioText {43, 207} {250, 80} label 0.000000 0.001000 "" center "Futura" 14 {0, 0, 0} {65535, 65535, 65535} nobackground border pitch
ioSlider {58, 233} {213, 34} 20.000000 5000.000000 2152.934082 pitch
ioGraph {333, 272} {389, 230}
ioText {145, 54} {289, 46} label 0.000000 0.001000 "" center "Futura" 12 {0, 0, 0} {65535, 58412, 50269} background border This is a simple interface to control our instrument.  A slider for pitch and a slider for amplitude.
ioText {341, 131} {314, 41} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border Click on the border of the slider to select it.  Once selected, you then will see its attributes in the panel above.
ioText {310, 168} {247, 64} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border Notice there is the channel name, which corresponds to the name specified in the "invalue" opcode in the orc.  You can also set the max/min range for the slider.
ioSlider {59, 147} {210, 34} 0.000000 10000.000000 4301.000000 amplitude
ioText {6, 7} {479, 36} label 0.000000 0.001000 "" center "Lucida Grande" 9 {0, 0, 0} {65535, 65535, 65535} nobackground noborder to edit this interface, first make sure you are in 'unlocked' mode.  if you do not see a number of buttons in the upper left corner, hit the button in the lower right corner of the window.
ioText {19, 315} {293, 47} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border To create a new object, just hit one of the buttons in the upper left corner of the window.  For an example, hit the text object button, the one with a 'T' on it.
ioText {19, 361} {293, 48} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border You should then see a new box text box.   Under the "Function" attribute, notice that it is set to "None [Static Label]"  This is how you can create comments like these.
ioText {19, 408} {293, 62} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border Now switch the function to "Value Display" and in the edit text box below type "pitch".  This will make the text box display the value of the "pitch" channel [the channel the pitch slider is writing to]
ioText {19, 469} {293, 26} label 0.000000 0.001000 "" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border Feel free to try creating or modifying other objects!
</MacGUI>
